########################################################################
# $Header: /var/local/cvsroot/4Suite/Ft/Server/Server/Commands/CommandUtil.py,v 1.7 2003/10/07 03:33:54 mbrown Exp $
"""
Functions used by various commands

Copyright 2003 Fourthought, Inc. (USA).
Detailed license and copyright information: http://4suite.org/COPYRIGHT
Project home, documentation, distributions: http://4suite.org/
"""

import os, sys, sha, getpass, posixpath

from Ft.Server.Server import SCore
from Ft.Server.Common import AclConstants, Schema
from Ft.Server.Server.Lib import ConfigFile, LogUtil

def GetRepository(options, cmdName):
    coreId = options.get('core-id',os.environ.get('FTSS_CORE_ID', 'Core'))
    properties = ConfigFile.Read(options.get('config-file'))
    properties = properties[coreId]

    if options.has_key('username'):
        userName = options['username']
    else:
        userName = os.environ.get('FTSS_USERNAME', None)

    #Nope, ask for it
    if not userName:
        sys.stderr.write('4SS Manager Name: ')
        sys.stderr.flush()
        userName = raw_input()

    if options.has_key('password'):
        passwdHash = sha.new(options['password']).hexdigest()
    else:
        passwdHash = os.environ.get('FTSS_PASSWORD', None)

    if passwdHash is None:
        passwdHash = sha.new(getpass.getpass("Password for %s: " % userName)).hexdigest()

    repo = SCore.GetRepository(userName, passwdHash, LogUtil.NullLogger(),
                               properties, verify=1)

    #Verify that the command can be run
    #verifyCommand(repo,cmdName)
    cmd = repo.getCommand(cmdName)
    if cmd is None:
        raise ValueError("Unknown Command: %s" % cmdName)
    cmd.verifyAcl(AclConstants.EXECUTE_ACCESS,0)
    return userName,passwdHash,properties,repo


